/* Copyright (c) 2007 Sam Trenholme
 *
 * TERMS
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * This software is provided 'as is' with no guarantees of correctness or
 * fitness for purpose.
 */

#include <stdio.h>
#include "DwSocket.h"

#ifdef MINGW
void windows_socket_start() {
        WSADATA wsaData;
        WORD wVersionRequested = MAKEWORD(2,2);
        WSAStartup( wVersionRequested, &wsaData);
}
#endif /* MINGW */

void usage() {
        printf("Usage: DwMain [-f dwood1rc]\n");
        exit(1);
}

/* Simple DNS load balancing server */
int main(int argc, char **argv) {
        int bind_count = 0; /* Number of IPs we bound to */
#ifdef IPV6
        printf("DwMain: A DNS UDP load balancer (IPv6 supported)\n");
#else /* IPV6 */
        printf("DwMain: A DNS UDP load balancer (IPv4-only)\n");
#endif /* IPV6 */
        if(argc != 1 && argc != 3) {
                usage();
        } else if(argc == 3) {
                if(argv[1] == 0 || argv[2] == 0) {
                        usage();
                } if(*(argv[1]) != '-' || *(argv[1] + 1) != 'f' ||
                     *(argv[1] + 2) != 0) {
                        usage();
                }
                process_mararc(argv[2]);
        } else {
                process_mararc("dwood1rc");
        }
        process_mararc_params();
#ifdef MINGW
        windows_socket_start();
#endif /* MINGW */
        bind_count = bind_all_udp();
        if(bind_count > 0) {
                printf("We bound to %d addresses\n",bind_count);
        } else {
                dw_fatal("Unable to bind to any IP addresses");
        }
#ifdef MINGW
        fflush(stdout);
#endif /* MINGW */
        init_rng();
        sandbox();
        init_b_remote();
        bigloop();
        return 0;
}

